
1000 'Lawson Labs, Inc.
1010 'DRIVR135 Datalogging Software   Version 1.0
1020 'October 3, 1992
1030 'To run this code from the environment use the /ah/lburst135 command
1040 'line parameters.
1050 DECLARE SUB BURSTS (BYVAL OFFS%) 'declare external asm code
1060 DECLARE SUB BURST1 (BYVAL OFFS%) 'declare external asm code
1070 DECLARE SUB BURSTS2 (BYVAL OFFS%) 'declare external asm code
1080 DECLARE SUB READCNT100 (BYVAL OFFS%) 'declare external asm code
1090 '**** the next 2 lines place the sample array in DGROUP so sample can
1100 '**** be passed by near reference to the asm code
1110 DIM sample(90) AS INTEGER: REM define burst
1120 COMMON sample() AS INTEGER
1130 KEY OFF
1140 CLS : LOCATE 12, 38: PRINT "WAIT"
1150 X = TIMER: IF X > 86398! THEN 1150   'time the computer
1160 DD = 0: X = X + 1: WHILE X > TIMER: DD = DD + 1: WEND: DELY% = DD / 30
1170 'sample(1-64) Each scan is of 1 to 4 points. The sequence of channels &
1180 '            control codes are stored here.
1190 'sample(65) The first control code (sample(1)) is repeated after the
1200 '           last. For 64-channel scans.
1210 'sample(66) A/D Converter address code (ADC) determined by DIP switches
1220 'sample(68) Interrupt flag 1=interrupts on during sampling, 0=off
1230 'sample(69) Starting memory segment for data table
1240 'sample(71) Interchannel delay for high impedance voltage sources
1250 'sample(72) Number of readings to average for each datapoint
1260 'sample(73) The power of 2 of sample%(8E)
1270 'sample(74) Low byte of scanning rate
1280 'sample(75) High byte of scanning rate
1290 'sample(76) Final ES: ie the segment address one byte past the end of
1300 '           the data table
1310 'sample(77) Final SI: ie the displacement into the final segment
1320 'sample(78) Number of data points per scan * 2
1330 'sample(79) Int(number of scans/512)
1340 'sample(80) Remainder of scans from sample(79) * 512
1350 'sample(83) Segment address one byte past last data point actually stored
1360 'sample(84) Offset address for sample(83) (used with above to determine
1370 '            if sampling was cut short)
1380 'sample(86) Scandelay lo word
1390 'sample(87) Scandelay hi word
1400 'sample(88) Timing flag, 0 = not timing, 1 = timing
1410 BURST% = 1: TFLG% = 1:   'flag need_to_do_timing
1420 NRATE = 1000                 'default scan rate
1430 XSAM$ = "DRIVR135.BIN"       'read drivr135.bin file
1440 ON ERROR GOTO 1500
1450 DEF SEG = VARSEG(sample(1))
1460 BLOAD XSAM$, VARPTR(sample(1))
1470 ON ERROR GOTO 0
1480 GOSUB 3820: GOSUB 1750       'alloc memory, set storage vars
1490 IF sample(66) <> 0 THEN GOTO 1520 ELSE GOTO 1800
1500 BURST% = 0: sample(72) = 1: sample(78) = 0: BEEP
1510 RESUME 1470           'could not read samarray.bas
1520 ADC = sample(66): LORATE = sample(74)
1530 IF sample(74) < 0 THEN LORATE = 65536! + sample(74)
1540 NRATE = (sample(75) * 65536!) + LORATE
1550 IF NRATE = 0 THEN NRATE = 1000
1560 SCANTIME = 1 / NRATE
1575 CLS : PRINT "Would you like time verify timing Y/N?": a$ = UCASE$(INPUT$(1))
1576 IF a$ = "N" THEN GOTO 1630
1577 IF a$ <> "Y" THEN GOTO 1575
1570 ORGRATE = NRATE: ORG86 = sample(86): ORG87 = sample(87):
1580 ORG79 = sample(79): ORG80 = sample(80)
1590 GOSUB 5110: GOSUB 3780: IF BTYP% <> 3 THEN 1600
1595 GOSUB 4750: IF ORGRATE > NRATE1 THEN 1605
1600 NRATE = ORGRATE: sample(86) = ORG86: sample(87) = ORG87
1605 sample(79) = ORG79: sample(80) = ORG80
1610 SCANS = sample(79): SCANS = (SCANS * 512) + sample(80)
1615 IF BTYP% <> 3 THEN SKIPFAST% = 1: TFLG% = 1: GOTO 2220
1620   ' burst set up
1630 sample(66) = ADC
1640 SCANS = sample(79): SCANS = (SCANS * 512) + sample(80)
1650 IF SCANS = 0 THEN SCANS = 1
1660 GOSUB 3490: GOSUB 3610        'display burst setup
1670 LOCATE 15, 10: PRINT "Press M to modify, C to continue, ESC to quit ";
1680 a$ = INPUT$(1)
1690 IF a$ = CHR$(27) THEN GOSUB 4480: END          'exit the program
1700 IF a$ = "C" OR a$ = "c" THEN GOTO 1720            'do the burst
1710 IF a$ = "M" OR a$ = "m" THEN GOTO 1800 ELSE 1670  'do burst setup
1720 BURST% = 1: GOSUB 1750:        'set storage vars
1730 OUT ADC, sample(1): DEF SEG    'output the first control code
1740 GOSUB 3920: CLS : GOTO 1620   'go do a burst
1750 X = sample(69): IF X < 0 THEN X = X + 65536! 'set data storage variables
1760 STARTSEG = X
1770 TABLELENGTH = ((sample(79) * 512! + sample(80)) * sample(78) / 2) * 2
1780 STARTTABLE = STARTSEG * 16
1790 RETURN
1800 IF sample(66) = 0 THEN 1840 ELSE ADC = sample(66)    'burst setup routine
1810 CLS : PRINT "ADC="; ADC; " Y/N?": a$ = INPUT$(1)
1820 IF a$ = "Y" OR a$ = "y" THEN 1850
1830 IF a$ = "N" OR a$ = "n" THEN 1840 ELSE 1800
1840 CLS : INPUT "Enter ADC (check your manual) "; ADC
1850 sample(66) = ADC
1860 X = INP(ADC + 2): GOSUB 4740      'delay for fast machines
1870 X = 0: FOR N = 0 TO 99: IF INP(ADC) AND 2 THEN  ELSE X = 1
1880 NEXT: IF X <> 1 THEN 1910       'found a 135 card
1890 CLS : PRINT "Unable to locate model 135 card, press ESC to exit, any other to retry"
1900 a$ = INPUT$(1): IF a$ = CHR$(27) THEN GOTO 1690 ELSE 1840
1910 SCANS = sample(79): SCANS = (SCANS * 512) + sample(80)
1920 CLS : PRINT "Interrupts O";
1930 IF sample(68) = 1 THEN PRINT "n";  ELSE PRINT "ff";
1940 PRINT " Y/N?": a$ = INPUT$(1): IF a$ = "Y" OR a$ = "y" THEN 1970
1950 IF a$ = "N" OR a$ = "n" THEN 1960 ELSE 1920
1960 sample(68) = ABS(sample(68) - 1): TFLG% = 1: GOTO 1920
1970 IF sample(78) = 0 THEN sample(78) = 2:     'set to 1 data point per scan
1980 CLS : PRINT "data points/scan= "; sample(78) / 2; " Y/N?"
1990 a$ = INPUT$(1): IF a$ = "Y" OR a$ = "y" THEN 2040
2000 IF a$ = "N" OR a$ = "n" THEN 2010 ELSE 1970
2010 CLS : INPUT "Enter number of data points per scan "; X
2020 IF X > 64 OR X < 1 THEN 2010 ELSE sample(78) = X * 2
2030 sample(X + 1) = sample(1): TFLG% = 1     'set last control code to first
2040 IF sample(78) <> 2 THEN GOTO 2045   ' not single channel scan
2041 IF BTYP% = 3 THEN sample(71) = 1 ELSE sample(71) = 0
2042 GOTO 2140
2045 CLS : PRINT "interchannel delay = "; " (";
2050 IF sample(71) = 1 THEN ID = 0 ELSE ID = sample(71)
2060 PRINT USING "##.###"; (ID / 1193.1816#);
2070 PRINT ") milliseconds  (Y/N)? ": a$ = INPUT$(1)
2080 IF a$ = "Y" OR a$ = "y" THEN 2140
2090 IF a$ = "N" OR a$ = "n" THEN 2100 ELSE 2040
2100 CLS : INPUT "Enter Interchannel delay in milliseconds (0 or .006-26) "; IDELAY
2110 IF (IDELAY < 0) OR (IDELAY > 26) THEN GOTO 2100
2120 IF IDELAY <> 0 THEN IF IDELAY < .006 THEN 2100
2130 TFLG% = 1: sample(71) = CINT(IDELAY * 1193.1816#): GOTO 2040
2140 CLS : PRINT "average "; sample(72); " samples/data point (Y/N)? "
2150 a$ = INPUT$(1): IF a$ = "Y" OR a$ = "y" THEN 2220
2160 IF a$ = "N" OR a$ = "n" THEN 2170 ELSE 2140
2170 CLS : P = 0: INPUT "Enter samples/point "; sample(72): TFLG% = 1
2180 IF sample(72) / 2 < 1 THEN sample(73) = P: sample(72) = 2 ^ P: GOTO 2140
2190 P = P + 1: sample(72) = sample(72) / 2: GOTO 2180
2200 IF sample(71) = 0 AND sample(73) > 0 THEN sample(71) = 1
2210 IF sample(78) = 0 THEN sample(78) = 2
2220 IF TFLG% = 0 THEN 3050
2225 ORGSCANS = SCANS: ORG68 = sample(68): GOSUB 5110
2230 GOSUB 3780
2231 IF BTYP% = 3 THEN
2232     GOSUB 4750: IF ORGRATE <= NRATE1 THEN GOTO 3040 'stay timer based
2233     IF (sample(71) > 5) OR (sample(72) <> 1) THEN GOTO 3040
2234     GOSUB 3490: SKIPFAST% = 1: sample(71) = 0       'leave timer based
2236     TFLG% = 2: GOSUB 3780: EXITIMER% = 1: NRATE = ORGRATE: GOTO 2250
2238 END IF
2240 SKIPFAST% = 0: GOSUB 3490             'flag must_enter_rate
2250 TRIES% = 0: LASTDELTAB = 2000000000#: IF BURST% = 0 THEN TFLG% = 0
2260 IF TFLG% = 0 THEN GOTO 3040          'timing is not necessary
2270 CLS : PRINT "Establishing the maximum scan rate": TFLG% = 2
2280 sample(68) = 0: sample(82) = 10000    'interrupts off, 10000 calls
2290 CALL READCNT100(VARPTR(sample(1)))    'to READCNT to establish overhead
2300 IF sample(81) < 0 THEN LO = sample(81) + 65536! ELSE LO = sample(81)
2310 IF sample(82) < 0 THEN HI = sample(82) + 65536! ELSE HI = sample(82)
2320 OVERHCNT = (LO + (HI * 65536!))      'total over head time
2330 SCANS = 10000: GOSUB 3490         'setup 10000 scan run
2340 sample(86) = 1                    'initial delay value for
2350 sample(87) = 0                    'shortest scan delay
2360 sample(88) = 1:  MAXRATE = 150000! / (sample(78) / 2)   'flag timing
2370 IF BTYP% = 1 THEN CALL BURST1(VARPTR(sample(1))) ELSE CALL BURSTS2(VARPTR(sample(1)))
2380 PRINT ".";
2390 IF sample(81) < 0 THEN LO = sample(81) + 65536! ELSE LO = sample(81)
2400 IF sample(82) < 0 THEN HI = sample(82) + 65536! ELSE HI = sample(82)
2410 ONESCAN = ((((LO + (HI * 65536!)) - OVERHCNT) / 1193181.6#) / SCANS)
2420 IF 1 / ONESCAN > MAXRATE THEN sample(86) = sample(86) + 1: LRATE = sample(86): GOTO 2360
2430 CLS : NRATE1 = (1 / ONESCAN)    ' found the maximum scan rate
2440 IF NRATE1 > MAXRATE THEN NRATE1 = MAXRATE
2450 IF NRATE > NRATE1 THEN
2460 NRATE = NRATE1: PRINT "MAXIMUM RATE IS "; : PRINT USING "########.##"; NRATE1
2470 PRINT "CURRENT RATE IS "; NRATE; "  (Y/N)"
2480 a$ = UCASE$(INPUT$(1)): IF a$ = "Y" THEN 2530
2490 IF a$ <> "N" THEN 2430
2500 IF SKIPFAST% <> 0 THEN 2520
2510 LOCATE 2, 1: PRINT SPACE$(40): LOCATE 2, 1: INPUT ; "ENTER DESIRED RATE"; NRATE
2520 IF (NRATE < 1) OR (NRATE > NRATE1 + .5) THEN SKIPFAST% = 0: GOTO 2430
2525 END IF
2530 IF EXITIMER% THEN EXITIMER% = 0: GOTO 2540
2535 GOSUB 5110: IF sample(88) = 0 THEN 2230
2540 POINT1% = 0: SCANTIME = 1           'flag doing 1 % check
2550 SCANDELAY = (NRATE1 / NRATE) * (DELY% / 10)  'first scandelay
2560 sample(88) = 1
2570 DEF SEG : LOCATE 10, 10: : CLS : PRINT "Verifying Scan Rate ";
2580 IF POINT1% = 1 THEN GOTO 2600                'doing .1 % check
2590 HI = INT(SCANDELAY / 65536!): LO = INT(SCANDELAY - (HI * 65536!))
2600 IF POINT1% = 1 THEN IF DELTAB > 0 THEN LO = LO + 1 ELSE LO = LO - 1
2605 IF LO = 0 THEN LO = 1
2610 IF LO > 65535! THEN LO = 0: HI = HI + 1
2620 IF HI > 32767 THEN HI% = HI - 65536! ELSE HI% = HI
2630 IF LO > 32767 THEN LO% = LO - 65536! ELSE LO% = LO
2640 ' if TRIES% = 10 then do 1 more check & use best scantime
2650 IF TRIES% = 10 THEN ZZ = ABS(DELTAB): LASTLO% = LO%: LASTHI% = HI%: LSCAN = SCANTIME
2660 IF TRIES% = 11 THEN IF ZZ < ABS(DELTAB) THEN LO% = LASTLO%: HI% = LASTHI%: SCANTIME = LSCAN
2670 sample(86) = LO%: sample(87) = HI%: IF LO% = 0 THEN sample(86) = 1
2680 DEF SEG
2690 SCANS = INT(NRATE / 10): IF SCANS < 1 THEN SCANS = 1  'do at least 1 scan
2700 sample(82) = SCANS                    'setup for .1 sec runs
2710 CALL READCNT100(VARPTR(sample(1)))    'establish overhead
2720 IF sample(81) < 0 THEN LOO = sample(81) + 65536! ELSE LOO = sample(81)
2730 IF sample(82) < 0 THEN HII = sample(82) + 65536! ELSE HII = sample(82)
2740 OVERHCNT = (LOO + (HII * 65536!))
2750 TARGET = NRATE * .01                           ' 1 % check
2760 IF POINT1% <> 0 THEN TARGET = TARGET * .1      '.1 % check
2770 sample(86) = LO%: sample(87) = HI%: IF LO% = 0 THEN sample(86) = 1
2780 IF TRIES% = 11 THEN GOTO 2880      'done verifying scan rate
2790 GOSUB 3490: sample(88) = 1         'flag timing
2800 IF BTYP% = 1 THEN CALL BURST1(VARPTR(sample(1))) ELSE CALL BURSTS2(VARPTR(sample(1)))
2810 IF sample(81) < 0 THEN LOO = sample(81) + 65536! ELSE LOO = sample(81)
2820 IF sample(82) < 0 THEN HII = sample(82) + 65536! ELSE HII = sample(82)
2830 SCANTIME = ((((LOO + (HII * 65536!)) - OVERHCNT) / 1193181.6#) / SCANS)
2840 IF SCANTIME = 0 THEN DELTAB = 1: GOTO 3010   'avoid divide by zero
2850 DELTAB = (1 / SCANTIME) - NRATE              'calc scan rate error
2860 IF ABS(DELTAB) < LASTDELTAB THEN LASTDELTAB = ABS(DELTAB): TRIES% = 0 ELSE TRIES% = TRIES% + 1
2870 IF ABS(DELTAB) > TARGET THEN GOTO 3010   'did not match the scan rate
2880 POINT1% = POINT1% + 1: TRIES% = 0 'matched the scan rate
2890 IF POINT1% > 1 THEN      'we are almost done
2900 IF NRATE < 10000! THEN GOTO 2980 'don't do correction for slow scan rates
2910 sample(88) = 0       'flag not timing
2920 SCANS = FIX(((MAXLEN / (sample(78) / 2)) - 10) / 2) 'large # of scans
2930 IF SCANS > NRATE * 2 THEN SCANS = INT(NRATE * 2)     'do a 2 second burst
2940 GOSUB 3490: sample(68) = 1    'interrupts on
2950 X = TIMER
2960 IF BTYP% = 1 THEN CALL BURST1(VARPTR(sample(1))) ELSE CALL BURSTS2(VARPTR(sample(1)))
2970 Y = TIMER: SCANTIME = ((Y - X) / SCANS)
2980 SCANS = ORGSCANS: sample(68) = ORG68: NRATE = 1 / SCANTIME: GOTO 3040
2990 sample(86) = LO%: sample(87) = HI%: IF LO% = 0 THEN sample(86) = 1
3000 END IF
3010 PRINT ".";
3020 IF POINT1% = 0 THEN IF DELTAB < 0 THEN SCANDELAY = SCANDELAY * .95 ELSE SCANDELAY = SCANDELAY * 1.05
3030 GOTO 2580       ' do timing again
3040 SCANS = ORGSCANS: sample(68) = ORG68
3050 CLS : LOCATE 21, 1
3060 IF NRATE1 > 1 THEN 3100
3070 PRINT "     Fastest scan rate is less than 1,"
3080 PRINT "     Change parameters for a faster scan, press any key to continue"
3090 a$ = INPUT$(1): GOTO 1800
3100 IF BTYP% <> 3 THEN LOCATE 23, 1: PRINT "Fastest rate                  ";
3110 IF BTYP% = 3 THEN LOCATE 23, 1: PRINT "Timer based fastest rate      ";
3120 PRINT USING "##########.##"; NRATE1; : PRINT " scans/second"
3130 TFLG% = 0: DELTAB = NRATE - NRATE1: IF DELTAB = 0 THEN SCANTIME = 1 / NRATE
3135 IF DELTAB > 0 THEN NRATE = NRATE1: SCANTIME = 1 / NRATE
3140 LOCATE 1, 1: PRINT "scan rate= "; : PRINT USING "##########.##"; NRATE;
3150 PRINT " scans/second (Y/N)? "
3160 a$ = INPUT$(1)
3170 IF a$ = "Y" OR a$ = "y" THEN IF BTYP% = 3 THEN 3350 ELSE 3280
3180 IF a$ = "N" OR a$ = "n" THEN 3190 ELSE 3050
3190 LOCATE 1, 1: PRINT SPACE$(80)                 'get scan rate
3200 LOCATE 1, 1: INPUT "Enter scan rate "; NRATE
3210 IF NRATE <= NRATE1 THEN 3260   'scan rate is less than the fastest rate
3220 IF BTYP% <> 3 THEN TFLG% = 2: GOTO 3280    'not in timer mode
3230 IF (sample(71) < 6) AND (sample(72) = 1) THEN 'get out of timer mode
3232     GOSUB 3490: SKIPFAST% = 1: sample(71) = 0
3234     TFLG% = 2: GOSUB 3780: EXITIMER% = 1: GOTO 2250
3235 END IF
3240 IF (sample(71) = 1) AND (sample(72) = 1) THEN sample(71) = 0: GOTO 3250
3242   CLS : PRINT "Reduce interchannel delay, or averaging to achieve faster rates"
3244   PRINT "Press any key to continue": a$ = INPUT$(1): TFLG% = 2: GOTO 3050
3250 TFLG% = 1: GOTO 2220 'scan rate is too fast
3260 IF NRATE < 1 THEN 3190                            'scan rate is too slow
3270 IF BTYP% = 3 THEN SCANTIME = 1 / NRATE: GOTO 3350
3280 IF ABS(NRATE - (1 / SCANTIME)) > 1 THEN SKIPFAST% = 1: TFLG% = 1: GOTO 2220
3290 IF NRATE <= 1 / SCANTIME + .5 THEN GOTO 3350
3300 NRATE = 1 / SCANTIME: GOTO 3280  'scan rate is ok
3310 LOCATE 1, 1: PRINT SPACE$(80): LOCATE 1, 1
3320 PRINT "Scan Rate can not be greater than ";
3330 PRINT USING "##########.##"; 1 / SCANTIME; : PRINT "  press any key to continue";
3340 a$ = INPUT$(1): GOTO 3190
3350 MAXSCANS = FIX(((MAXLEN / (sample(78) / 2)) - 2) / 2)
3360 IF SCANS > MAXSCANS THEN SCANS = MAXSCANS
3370 IF SCANS = 0 THEN SCANS = 1
3380 CLS : PRINT SCANS; " scans per sampling run (Y/N)? ": a$ = INPUT$(1)
3390 IF a$ = "Y" OR a$ = "y" THEN 3470
3400 IF a$ = "N" OR a$ = "n" THEN 3410 ELSE 3380
3410 CLS
3420 INPUT "Enter scans per sampling run "; SCANS
3430 SCANS = INT(SCANS): IF SCANS <= 0 THEN GOTO 3410
3440 IF SCANS <= MAXSCANS THEN 3470
3450 PRINT : PRINT "NOT ENOUGH MEMORY", "MAXIMUM NUMBER OF SCANS = "; MAXSCANS
3460 PRINT : GOTO 3420
3470 GOSUB 3490: IF TABLELENGTH < MAXLEN THEN GOTO 1640 ELSE GOTO 3420
3480 '   setup data storage variables
3490 MAXSCANS = FIX(((MAXLEN / (sample(78) / 2)) - 2) / 2)
3500 IF SCANS > MAXSCANS THEN SCANS = MAXSCANS
3510 sample(79) = INT(SCANS / 512): sample(80) = SCANS - sample(79) * 512!
3520 TABLELENGTH = SCANS * sample(78) / 2: TABLELENGTH = TABLELENGTH * 2
3530 ENDTABLE = STARTTABLE + TABLELENGTH
3540 X = STARTTABLE / 16 + INT(TABLELENGTH / 65536!) * 4096
3550 IF X > 32767 THEN X = X - 65536!
3560 IF X > 32767 THEN SCANS = INT(SCANS - (X - 32000) / sample(78)): GOTO 3490
3570 sample(76) = X
3580 X = TABLELENGTH - INT(TABLELENGTH / 65536!) * 65536!
3590 IF X > 32767 THEN X = X - 65536!
3600 sample(77) = X: BURST% = 1: RETURN
3610   'display burst setup
3620 CLS : PRINT "adc="; sample(66)
3630 PRINT "Interrupts o"; : IF sample(68) = 1 THEN PRINT "n" ELSE PRINT "ff"
3640 IF sample(71) = 1 THEN ID = 0 ELSE ID = sample(71)
3650 PRINT "Interchannel delay "; : PRINT USING "##.###"; (ID / 1193.1816#);
3660 PRINT " milliseconds"
3670 PRINT "Average "; sample(72); " samples/data point "
3680 PRINT "Scanning rate ="; : PRINT USING "########.##"; NRATE;
3685 PRINT " scans/second"
3690 PRINT "Scans per sample run ="; SCANS: PRINT : PRINT
3700 PRINT "Sample run duration =";
3710 IF SCANS = 1 THEN STIME = .5 ELSE STIME = SCANS - 1
3720 PRINT USING "#####.###"; STIME / NRATE; : PRINT " seconds"
3730 X = sample(76): IF X < 0 THEN X = X + 65536!
3740 Y = sample(77): IF Y < 0 THEN Y = Y + 65536!
3750 PRINT "Data table from "; STARTTABLE; " to "; X * 16 + Y
3760 PRINT "Table length ="; TABLELENGTH
3770 PRINT "Data points per scan ="; sample(78) / 2
3780 IF sample(78) = 2 THEN BTYP% = 1 ELSE BTYP% = 2
3790 IF (sample(72) <> 1) OR (sample(71) <> 0) THEN BTYP% = 3
3800 IF BTYP% = 3 THEN
3801   PRINT "Timer based maximum rate = ";
3802   IF NRATE1 = 0 THEN PRINT "???";  ELSE PRINT USING "######.##"; NRATE1;
3804   PRINT " scans/second"
3806 END IF
3810 RETURN
3820 REM allocate all memory
3830 X = (FRE(-1) / 128) - 512     'get free memory
3840 MAXLEN = (X * 128) - 512      'set max memory we will use
3850 IF MAXLEN < 100 THEN CLS : PRINT "NOT ENOUGH MEMORY TO RUN PROGRAM": END
3860 DIM X9(X) AS STRING * 128     'allocate the memory
3870 VARS = VARSEG(X9(0)): VARO = VARPTR(X9(0))
3880 TABLESTART = INT(VARS * 16!) + INT((VARO / 16) + 1) * 16 + 350
3890 X = INT(TABLESTART / 16): IF X > 32767 THEN X = X - 65536!
3900 IF sample(69) <> X THEN BURST% = 0     'memory table moved
3910 sample(69) = X: RETURN
3920 ' do the burst
3930 CLS : PRINT "Do you want to load an existing data file (Y/N)? ";
3940 a$ = INPUT$(1): IF a$ = "N" OR a$ = "n" THEN 4030
3950 IF a$ = "Y" OR a$ = "y" THEN GOTO 4560 ELSE GOTO 3930
3960 CLS : LOCATE 25, 10: PRINT "Press RETURN to leave unchanged."
3970 LOCATE 1, 1: FOR N = 1 TO sample(78) / 2
3980 PRINT "Enter control code for data point "; N; " "; : LOCATE , 41
3990 PRINT sample(N); : LOCATE , 40
4000 INPUT a$: IF LEN(a$) > 0 THEN sample(N) = VAL(a$)
4010 NEXT N
4020 sample(N) = sample(1)   'set last control code to first
4025 OUT ADC, sample(1): DEF SEG    'output the first control code
4030 CLS : PRINT "Review or revise control codes (Y/N)? "; : a$ = INPUT$(1)
4040 IF a$ = "Y" OR a$ = "y" THEN 3960
4050 IF a$ = "N" OR a$ = "n" THEN 4060 ELSE 4030
4060 CLS : PRINT "Press space to begin sampling or R to restart. ";
4070 a$ = INPUT$(1): CLS
4080 IF a$ = "r" OR a$ = "R" THEN B$ = CHR$(27): GOTO 4480
4090 IF a$ <> " " THEN GOTO 4060
4100 IF SCANS = 1 THEN STIME = .5 ELSE STIME = SCANS - 1
4110 PRINT "Sampling will take"; STIME / NRATE; "seconds"
4120 sample(88) = 0
4130 IF BTYP% = 3 THEN GOSUB 5030: CALL BURSTS(VARPTR(sample(1))): GOTO 4150
4140 IF BTYP% = 1 THEN CALL BURST1(VARPTR(sample(1))) ELSE CALL BURSTS2(VARPTR(sample(1)))
4150 PRINT "Sampling complete."
4160 PRINT "Do you want to save the data as a text file (Y/N)? ";
4170 a$ = INPUT$(1)
4180 IF a$ = "n" OR a$ = "N" THEN TEXTSAVE = 0: GOTO 4280
4190 IF a$ <> "y" AND a$ <> "Y" THEN 4160 ELSE TEXTSAVE = 1
4200 CLS : PRINT "Enter the full file specification for a new text file", , "or \ for no new file. ";
4210 INPUT FSPEC$
4220 IF FSPEC$ = "\" THEN TEXTSAVE = 0: GOTO 4280
4230 PRINT : PRINT "Save as "; FSPEC$; " ? "; : a$ = INPUT$(1)
4240 IF a$ = "N" OR a$ = "n" THEN 4200
4250 IF a$ <> "Y" AND a$ <> "y" THEN 4230
4260 ON ERROR GOTO 4710
4270 OPEN FSPEC$ FOR OUTPUT AS #1: ON ERROR GOTO 0
4280 CLS : DS = STARTSEG   'DS = STARTTABLE / 16
4290 DEF SEG = DS
4300 LOCATE 25, 25: PRINT "Press space to pause.": LOCATE 1, 1
4310 INDEX = 0: FOR SCAN = 1 TO SCANS
4320 PRINT USING "Scan########"; SCAN; : PRINT "    ";
4330 FOR DATAPOINT = 1 TO sample(78) / 2
4340 Z = PEEK(INDEX + 1): Z = Z * 256 + PEEK(INDEX)
4345 Z = (Z - 32768!) * 1.52588E-04: REM scale in volts
4350 PRINT USING "    ##.####"; Z;
4360 IF TEXTSAVE = 1 THEN PRINT #1, Z;
4370 INDEX = INDEX + 2
4380 IF INDEX = 65536! THEN INDEX = 0: DS = DS + 4096: DEF SEG = DS
4390 NEXT DATAPOINT
4400 PRINT : IF TEXTSAVE = 1 THEN WRITE #1,
4410 IF INKEY$ = " " THEN 4430
4420 NEXT SCAN
4430 ROW = CSRLIN
4440 LOCATE 25, 15: PRINT "Press space to continue, ESC to quit                ";
4450 B$ = INPUT$(1): IF B$ = CHR$(27) THEN 4480
4460 IF B$ = " " AND SCANS >= SCAN THEN LOCATE 25, 15: PRINT SPACE$(10); "Press space to pause."; SPACE$(22); : LOCATE ROW, 1: GOTO 4420
4470 IF (B$ <> " ") THEN 4440
4480 CLOSE : CLS
4490 PRINT "Do you want to save the array that defines the sample run (Y/N)? ";
4500 a$ = INPUT$(1)
4510 IF a$ = "n" OR a$ = "N" THEN RETURN
4520 IF a$ <> "y" AND a$ <> "Y" THEN PRINT : GOTO 4480
4530 GOSUB 5160: DEF SEG : BSAVE "DRIVR135.BIN", VARPTR(sample(1)), 180
4540 RETURN
4550 RESUME NEXT
4560 CLS : REM reprocess files
4570 PRINT "Enter the full file specification of the existing data file to load", "or the drive letter (A B C or D) for the disk directory", , "or \ for no files ";
4580 INPUT a$: CLS : IF a$ = "\" THEN RETURN
4590 IF LEN(a$) = 0 THEN 4560
4600 IF LEN(a$) > 1 THEN 4630 ELSE a = ASC(a$): IF a > 95 THEN a = a - 32
4610 ON ERROR GOTO 4690
4620 IF a > 64 AND a < 69 THEN a$ = a$ + ":*.*": LOCATE 25, 20: PRINT "Press space to continue": FILES a$: B$ = INPUT$(1): LOCATE 25, 20: PRINT SPC(27); : GOTO 4570
4630 DEF SEG = STARTTABLE / 16
4640 ON ERROR GOTO 4670
4650 BLOAD a$, 0: ON ERROR GOTO 0
4660 CLS : GOTO 4160
4670 PRINT "Can't find file. Press space to continue.": X$ = INPUT$(1)
4680 RESUME 4560
4690 CLS : PRINT "No such drive. Press space to continue. ": X$ = INPUT$(1)
4700 RESUME 4560
4710 PRINT : PRINT "Can't open file. Press space to continue. ": X$ = INPUT$(1)
4720 RESUME 4200
4730 CLEAR : GOTO 1000    'clear all variables and restart the program
4740 FOR DDELAY = 1 TO DELY%: NEXT DDELAY: RETURN   'delay for fast machines
4750 IF TFLG% = 0 THEN RETURN   'timing routine for BTYP%= 3
4760 TFLG% = 0: ORGRATE = NRATE
4770 SAMPS = sample(78) / 2
4775 IF sample(71) = 1 THEN IDEL% = 0 ELSE IDEL% = sample(71)
4780 FRATE = 1 / ((((IDEL% / 1193181.6#) * SAMPS + ((SAMPS * sample(72)) * .000006))))
4785 IF (IDEL% = 0) AND (sample(72) = 1) THEN FRATE = FRATE * (DELY% / 100)
4787 IF FRATE > 160000 THEN FRATE = 160000
4790 IF ONETIME% THEN IF NRATE > (FRATE) * 1.1 THEN sample(88) = 1: TFLG% = 1: RETURN
4800 IF ONETIME% = 0 THEN NRATE = (FRATE)
4810 CLS : PRINT "Verifying Scan Rate ";
4820 CFACTOR = .8: LASTRATE = NRATE
4830 SCANS = INT(NRATE / 10)               'do .1 second scan
4840 SCANTIME = 1 / NRATE
4850 IF SCANS < 1 THEN SCANS = 1           'make sure at least 1 scan
4860 sample(88) = 1                'flag timing
4870 GOSUB 3490: GOSUB 5030: OUT ADC, sample(1): DEF SEG  'output first control code
4880 CALL BURSTS(VARPTR(sample(1)))
4890 IF ONETIME% = 1 THEN RETURN
4900 IF CFACTOR < 1 THEN IF sample(88) = 0 THEN GOTO 4970          'didn't miss any data
4905 IF CFACTOR > 1 THEN IF sample(88) <> 0 THEN GOTO 4970          'didn't miss any data
4910 PRINT ".";
4920 LASTRATE = NRATE: NRATE = NRATE * CFACTOR 'decrease scan rate
4930 sample(88) = 1: SCANTIME = 1 / NRATE
4940 GOTO 4830
4970 IF CFACTOR = .8 THEN CFACTOR = .95: NRATE = LASTRATE: GOTO 4930
4972 IF CFACTOR = .95 THEN CFACTOR = 1.01: GOTO 4930
4973 NRATE = LASTRATE
4980 NRATE1 = NRATE
4990 IF NRATE > ORGRATE THEN NRATE = ORGRATE
5000 SCANS = ORGSCANS 'got scan rate
5010 SCANTIME = 1 / NRATE
5020 RETURN
5030 SCANTIME = 1 / NRATE: SCANDELAY = SCANTIME * 1193181.6# 'setup scan delay
5040 HI = INT(SCANDELAY / 65536!)
5050 IF HI > 32767 THEN HI% = HI - 65536! ELSE HI% = HI
5060 LO = INT(SCANDELAY - (HI% * 65536!))
5070 IF LO > 32767 THEN LO% = LO - 65536! ELSE LO% = LO
5080 sample(86) = LO%
5090 sample(87) = HI%
5100 RETURN
5110 ONETIME% = 1: ORG86 = sample(86): ORG87 = sample(87): ORGRATE = NRATE
5120 GOSUB 4770: ONETIME% = 0
5130 IF sample(88) = 0 THEN IF sample(71) = 0 THEN sample(71) = 1: GOTO 5150
5140 IF sample(88) <> 0 THEN IF sample(71) = 1 THEN sample(71) = 0
5150 sample(87) = ORG87: sample(86) = ORG86: NRATE = ORGRATE: RETURN
5160 HI = INT(NRATE / 65536!)                'save scanning rate
5170 IF HI > 32767 THEN HI% = HI - 65536! ELSE HI% = HI
5180 LO = INT(NRATE - (HI% * 65536!))
5190 IF LO > 32767 THEN LO% = LO - 65536! ELSE LO% = LO
5200 sample(74) = LO%: sample(75) = HI%
5210 RETURN


